// PROCESORASYNIMPL.H : Declaration of the TProcesorAsynImpl

#ifndef ProcesorAsynImplH
#define ProcesorAsynImplH

#define ATL_FREE_THREADED

#include "SerwerAsyn_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TProcesorAsynImpl     Implements IProcesorAsyn, default interface of ProcesorAsyn
//                  and IProcesorAsynEvents, the default source interface
// ThreadingModel : Free
// Dual Interface : TRUE
// Event Support  : TRUE
// Default ProgID : SerwerAsyn.ProcesorAsyn
// Description    : Koklasa COM-obiektw asynchronicznych 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TProcesorAsynImpl : 
  public CComObjectRootEx<CComMultiThreadModel>,
  public CComCoClass<TProcesorAsynImpl, &CLSID_ProcesorAsyn>,
  public IConnectionPointContainerImpl<TProcesorAsynImpl>,
  public TEvents_ProcesorAsyn<TProcesorAsynImpl>, 
  public IDispatchImpl<IProcesorAsyn, &IID_IProcesorAsyn, &LIBID_SerwerAsyn>
{
public:
  TProcesorAsynImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otFree);
  DECLARE_PROGID("SerwerAsyn.ProcesorAsyn");
  DECLARE_DESCRIPTION("Koklasa COM-obiektw asynchronicznych ");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TProcesorAsynImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TProcesorAsynImpl)
  COM_INTERFACE_ENTRY(IProcesorAsyn)
  COM_INTERFACE_ENTRY2(IDispatch, IProcesorAsyn)
  COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(TProcesorAsynImpl)
  CONNECTION_POINT_ENTRY(DIID_IProcesorAsynEvents)
END_CONNECTION_POINT_MAP()

// IProcesorAsyn
public:
  STDMETHOD(PodajParamProcesorAsyn());
protected:
  char dane[200];

};

#endif //ProcesorAsynImplH
