// PROCESORYIMPL.H : Declaration of the TProcesoryImpl

#ifndef ProcesoryImplH
#define ProcesoryImplH

#define ATL_FREE_THREADED

#include "SerwerProcesor_TLB.h"


/////////////////////////////////////////////////////////////////////////////
// TProcesoryImpl     Implements IProcesory, default interface of Procesory
// ThreadingModel : Free
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : ProjectProcesor.Procesory
// Description    : Serwer prosty 
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TProcesoryImpl : 
  public CComObjectRootEx<CComMultiThreadModel>,
  public CComCoClass<TProcesoryImpl, &CLSID_Procesory>,
  public IDispatchImpl<IProcesory, &IID_IProcesory, &LIBID_SerwerProcesor>
{
public:
  TProcesoryImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otFree);
  DECLARE_PROGID("SerwerProcesor.Procesory");
  DECLARE_DESCRIPTION("Serwer prosty ");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TProcesoryImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TProcesoryImpl)
  COM_INTERFACE_ENTRY(IProcesory)
  COM_INTERFACE_ENTRY2(IDispatch, IProcesory)
END_COM_MAP()

// IProcesory
public:
 
  STDMETHOD(PodajParamProcesor(LPSTR* Param));
};

#endif //ProcesoryImplH
