//---------------------------------------------------------------------------

#include <vcl.h>
#include <objbase.h>
#include <objidl.h>
#include <winerror.h>
#include <winnt.h>
///#include <wtypes.h>
//#include <oledb.h>
#include <wstring.h>
#pragma hdrstop

#include "UnitMain.h"
const char chJpg[]="inp.jpg";
const char chTxt[]="inp.txt";
const char cOutJpg[]="out.jpg";
const char chTest[]="test.stg";
const wchar_t wcIStream1[]=L"IStream1";/* nazwa obiektu strumeniowego */
const wchar_t wcIStream2[]=L"IStream2";/* nazwa obiektu strumeniowego */
IStorage* pRootStorage=NULL;
IStream* pIStream1=NULL;
IStream* pIStream2=NULL;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZapisClick(TObject *Sender)
{
  MemoInfo->Clear();
  AnsiString asStg=ExtractFilePath(ParamStr(0))+AnsiString(chTest);
  WideString wsStg=WideString(asStg);/*nazwa pliku zoonego*/
  wchar_t* wcStg=wsStg.Copy();/*nazwa pliku zoonego*/
  HRESULT hr=StgCreateDocfile(
    wcStg, /*nazwa pliku zoonego*/
    STGM_CREATE | STGM_READWRITE | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    0,/*zarezerwowano, powinno by zero*/
    &pRootStorage /*adres wskanika na obiekt skadowania*/
  );
  if (hr!=S_OK)
  {
    if (hr==STG_E_INVALIDFLAG)
      MemoInfo->Lines->Add("Bdna kombinacja opcji w argumencie grfMode");
    return;
  }
  //----------------
  MemoInfo->Lines->Add("Plik zoony jest otworzony");
  //----------------
  hr = pRootStorage->CreateStream(
    wcIStream1,/* nazwa obiektu strumeniowego */
    STGM_CREATE | STGM_READWRITE | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    0,/* zarezerwowano, powinno by zero */
    0,/* zarezerwowano, powinno by zero */
    &pIStream1 /*adres wskanika na obiekt strumeniowy*/
  );
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Niepowodzenie z IStream1");
    return;
  }
  //----------------
  MemoInfo->Lines->Add("Stworzony jest obiekt strumeniowy IStream1");
  //----------------
  AnsiString asTxt=ExtractFilePath(ParamStr(0))+AnsiString(chTxt);
  TMemoryStream* pms1 = new TMemoryStream();
  pms1->LoadFromFile(asTxt);
  __int8* pmem1=(__int8*)pms1->Memory;
  unsigned long size1=pms1->Size;
  unsigned long numb1=0;
  pIStream1->Write(pmem1,size1,&numb1);
  if(numb1!=size1)
  {
    MemoInfo->Lines->Add("IStream1: rozmiary nie s rwne (Zapis)");
    return;
  }
  //----------------
  if (pms1) delete pms1;
  MemoInfo->Lines->Add("Jest zapisany obiekt strumeniowy IStream1");
  Memo1->Lines->LoadFromFile(asTxt);
  //---Stream2------------
  hr = pRootStorage->CreateStream(
    wcIStream2,/* nazwa obiektu strumeniowego */
    STGM_CREATE | STGM_READWRITE | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    0,/* zarezerwowano, powinno by zero */
    0,/* zarezerwowano, powinno by zero */
    &pIStream2 /*adres wskanika na obiekt strumeniowy */
  );
  if (hr!=S_OK || pIStream2==NULL)
  {
    MemoInfo->Lines->Add("Niepowodzenie z IStream2");
    return;
  }
  //----------------
  MemoInfo->Lines->Add("Stworzony jest obiekt strumeniowy IStream2");
  //----------------
  AnsiString asJpg=ExtractFilePath(ParamStr(0))+AnsiString(chJpg);
  //-----------
  TMemoryStream* pms2 = new TMemoryStream();
  pms2->LoadFromFile(asJpg);
  __int8* pmem2=(__int8*)pms2->Memory;
  unsigned long size2=pms2->Size;
  unsigned long numb2=0;
  pIStream2->Write(pmem2,size2,&numb2);
  if(numb2!=size2)
  {
    MemoInfo->Lines->Add("IStream2 (Zapis): rozmiary s rne");
    return;
  }
  //----------------
  if (pms2) delete pms2;
  MemoInfo->Lines->Add("Obiekt strumeniowy IStream2 jest zapisany");
  Image1->Picture->LoadFromFile(asJpg);
  //----------------------------------------
  if (pRootStorage) { pRootStorage->Release(); pRootStorage=NULL; }
  if (pIStream1) { pIStream1->Release(); pIStream1=NULL; }
  if (pIStream2) { pIStream2->Release(); pIStream2=NULL; }
}
/* grfMode:
STGM_DIRECT 0x00000000L
STGM_TRANSACTED 0x00010000L
STGM_SIMPLE 0x08000000L
STGM_READ 0x00000000L
STGM_WRITE 0x00000001L
STGM_READWRITE 0x00000002L
STGM_SHARE_DENY_NONE 0x00000040L
STGM_SHARE_DENY_READ 0x00000030L
STGM_SHARE_DENY_WRITE 0x00000020L
STGM_SHARE_EXCLUSIVE 0x00000010L
STGM_PRIORITY 0x00040000L
STGM_DELETEONRELEASE 0x04000000L
STGM_CREATE 0x00001000L
STGM_CONVERT 0x00020000L
STGM_FAILIFTHERE 0x00000000L
STGM_NOSCRATCH 0x00100000L
*/
/*
Return Values
S_OK
Indicates the compound file was successfully created.
STG_E_ACCESSDENIED
Access denied because the caller has insufficient permission, or another caller has the file open and locked.
STG_E_LOCKVIOLATION
Access denied because another caller has the file open and locked.
STG_E_FILEALREADYEXISTS
Indicates the compound file already exists and grfMode is set to STGM_FAILIFTHERE.
STG_S_CONVERTED
Indicates the specified file was successfully converted to Storage format.
STG_E_INSUFFICIENTMEMORY
Indicates the compound file was not created due to a lack of memory.
STG_E_INVALIDNAME
Indicates bad name in the pwcsName parameter.
STG_E_INVALIDPOINTER
Indicates bad pointer in the pwcsName parameter or the ppStgOpen parameter.
STG_E_INVALIDFLAG
Indicates bad flag combination in the grfMode pointer.
STG_E_TOOMANYOPENFILES
Indicates the compound file was not created due to a lack of file handles.
*/
/***      //---lub------------------------------------
      {Create a memory OleStream}
   TOleStream* pOleStream=new TOleStream;
   pOleStream->Create(  pIStream  );

      {Save the memo's text to the OleStream}
   Memo1->Lines.SaveToStream(  pOleStream  );

      {Finished with the OleStream}
   pOleStream->Free;
      //----------------------------------------
      ****/
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonZamknijClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonOdczytClick(TObject *Sender)
{
HRESULT hr;
  //-----------------
  MemoInfo->Clear();
  AnsiString asStg=ExtractFilePath(ParamStr(0))+AnsiString(chTest);
  WideString wsStg=WideString(asStg);/*nazwa pliku zoonego*/
  wchar_t* wcStg=wsStg.Copy();/*nazwa pliku zoonego*/
  hr=StgIsStorageFile(wcStg);
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Nie jest to plik zoony");
    return;
  }
  //-----------------
  hr=StgOpenStorage(
    wcStg, /*nazwa pliku zoonego*/
    NULL,/*zarezerwowano, powinno by NULL */
    STGM_READ | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    NULL,/*zarezerwowano, powinno by NULL */
    0,/*zarezerwowano, powinno by zero*/
    &pRootStorage /*adres wskanika na obiekt skadowania*/
    );
  if (hr!=S_OK)
  {
    if (hr==STG_E_INVALIDFLAG)
      MemoInfo->Lines->Add("Bdna kombinacja opcji w argumencie grfMode");
    else if (hr==STG_E_LOCKVIOLATION)
      MemoInfo->Lines->Add("Plik jest zablokowany");
    else
      MemoInfo->Lines->Add("Bd");
    return;
  }
  //--------------------
  MemoInfo->Lines->Add("Jest otworzony plik zoony");
  //--------------------
  hr = pRootStorage->OpenStream(
    wcIStream1,/* nazwa obiektu strumeniowego */
    NULL,/*zarezerwowano, powinno by NULL */
    STGM_READ | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    0,//zarezerwowano, powinno by zero
    &pIStream1 /*adres wskanika na obiekt strumeniowy*/
  );
  if (hr!=S_OK)
  {
    if (hr==STG_E_INVALIDFLAG)
      MemoInfo->Lines->Add("Bdna kombinacja opcji w argumencie grfMode");
    else MemoInfo->Lines->Add("Niepowodzenie z OpenStream (IStream1)");
    return;
  }
  //----------------
  MemoInfo->Lines->Add("Jest otworzony obiekt strumeniowy IStream1");
  //----------------
  STATSTG stg1;
  hr=pIStream1->Stat(&stg1, 1);/* 1 - nie jest potrzebna nazwa*/
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Niepowodzenie ze waciwoci Stat() (IStream1)");
    return;
  }
  unsigned int len1=stg1.cbSize.QuadPart;//ULARGE_INTEGER cbSize
  unsigned long numb1=0;
  __int8* pbuf1=new __int8[1+len1];/* plus bajt dla '\0' */
  hr=pIStream1->Read(pbuf1,len1,&numb1);
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Niepowodzenie z procedur Read() (IStream1)");
    return;
  }
  if(numb1!=len1)
  {
    MemoInfo->Lines->Add("IStream1 (Odczyt): rozmiary nie s rwne");
    return;
  }
  //----------------------------------------
  MemoInfo->Lines->Add("Jest przeczytany obiekt strumeniowy IStream1");
  pbuf1[len1]='\0';
  Memo2->Text=AnsiString(pbuf1);
  if (pbuf1) delete [] pbuf1;
  //---Stream2------------
  hr = pRootStorage->OpenStream(
    wcIStream2,/* nazwa obiektu strumeniowego */
    NULL,/*zarezerwowano, powinno by NULL */
    STGM_READ | STGM_SHARE_EXCLUSIVE,/*opcje trybu dostepu*/
    0,/*zarezerwowano, powinno by zero */
    &pIStream2 /*adres wskanika na obiekt strumeniowy*/
  );
  if (hr!=S_OK)
  {
    if (hr==STG_E_INVALIDFLAG)
      MemoInfo->Lines->Add("Bdna kombinacja opcji w argumencie grfMode");
    else
      MemoInfo->Lines->Add("Niepowodzenie z OpenStream (IStream2)");
    return;
  }
  //----------------
  MemoInfo->Lines->Add("Jest otworzony obiekt strumeniowy IStream2");
  //----------------
  STATSTG stg2;
  hr=pIStream2->Stat(&stg2, 1);/* 1 - nie jest potrzebna nazwa*/
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Niepowodzenie ze waciwoci Stat() (IStream2)");
    return;
  }
  //----------------
  unsigned int len2=stg2.cbSize.QuadPart;//ULARGE_INTEGER cbSize
  unsigned long numb2=0;
  __int8* pbuf2=new __int8[len2];
  hr=pIStream2->Read(pbuf2,len2,&numb2);
  if (hr!=S_OK)
  {
    MemoInfo->Lines->Add("Niepowodzenie z procedur Read() (IStream2)");
    return;
  }
  AnsiString asOutJpg=ExtractFilePath(ParamStr(0))+AnsiString(cOutJpg);
  TFileStream* pfs2 = new TFileStream(asOutJpg,fmCreate);
  pfs2->Write(pbuf2,len2);
  if (pfs2) delete pfs2;
  //----------------
  Image2->Picture->LoadFromFile(asOutJpg);
  //----------------
  MemoInfo->Lines->Add("Jest przeczytany obiekt strumeniowy IStream2");
  //----------------
  if (pbuf2) delete [] pbuf2;
  //----------------------------------------
  if (pRootStorage) { pRootStorage->Release(); pRootStorage=NULL; }
  if (pIStream1) { pIStream1->Release(); pIStream1=NULL; }
  if (pIStream2) { pIStream2->Release(); pIStream2=NULL; }
}
//---------------------------------------------------------------------------



