//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitData.h"
#include "UnitMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
///const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
///const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
  ShortDateFormat = ("yyyy-mm-dd");
  //----------------------------
  BaseFileName = "dbZodiak.ADTG";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as1=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z obiektami klasy*/
  //==========================================================

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZnakZodiakuClick(TObject *Sender)
{
  if (ZodiakDataModule->ADOConnectionZodiak->Connected==false)
  {
    WideString ws1="FILE NAME=";
///    WideString ws2=DataLinkDir();
    WideString ws2= ExtractFilePath(Application->ExeName);
    WideString ws3=ws2+WideString("\\dbZodiak.UDL");
    WideString ws=ws1+ws3;
    ZodiakDataModule->ADOConnectionZodiak->ConnectionString = ws;
    LoadData();
  }
  //--------------------
  PokazZnakInform(ZodiakDataModule->ADODataSetZodiak,MemoInfo->Lines);
  //----------------
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonClearClick(TObject *Sender)
{
  MemoInfo->Lines->Clear();

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZamknijClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadData()
{
  DataFileName = ExtractFilePath(ParamStr(0))+ BaseFileName;
  // If a persisted datafile exists, assume we exited in a disconnected
  // (offline) state and load the data from the file.
  if (FileExists(DataFileName))
  {
    ZodiakDataModule->ADODataSetZodiak->LoadFromFile(DataFileName);
  }
  else
  {
    // Otherwise establish the connection and get data from the database
    CheckBoxConnect->Checked = true;
    ZodiakDataModule->ADODataSetZodiak->Open();
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateData()
{
  // Connect to the database and send the pending updates }
  CheckBoxConnect->Checked = true;
  ZodiakDataModule->ADODataSetZodiak->UpdateBatch(arAll);
  DeleteFile(DataFileName);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveData()
{
  ZodiakDataModule->ADODataSetZodiak->SaveToFile(DataFileName, pfADTG);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZapisywanieClick(TObject *Sender)
{
  SaveData();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if(ZodiakDataModule->ADODataSetZodiak->Active)
  {
    try
    {
    // When closing, update the database if connected or save it to disk if not
      if (ZodiakDataModule->ADOConnectionZodiak->Connected)
        UpdateData();
      else
        SaveData();
    }
    catch(Exception &E)
    {
      CanClose = MessageDlg("Dane nie s zapisane/przypisane, czy wyj?", mtConfirmation,
              TMsgDlgButtons() <<mbYes <<mbNo <<mbCancel, 0)== mrYes;
    }
  }

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CheckBoxConnectClick(TObject *Sender)
{
  if(CheckBoxConnect->Checked)
  {
    // Toggle the connections state
    ZodiakDataModule->ADOConnectionZodiak->Open("", "");
    ZodiakDataModule->ADODataSetZodiak->Connection = ZodiakDataModule->ADOConnectionZodiak;
    ZodiakDataModule->ADODataSetZodiak->Open();
  }
  else
  {
    // Note here you must clear the connection property of the
    // dataset before closing the connection.  Otherwise the dataset
    // will close with the connection.
    ZodiakDataModule->ADODataSetZodiak->Connection = NULL;
    ZodiakDataModule->ADOConnectionZodiak->Close();
  }

}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ButtonPrzepiszClick(TObject *Sender)
{
  UpdateData();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonOdswiezClick(TObject *Sender)
{
  //------------------------
  // Close and reopen the dataset to refresh the data.  Note that in this demo
  // there is no checking for pending updates so they are lost if you click
  // the refresh data button before clicking the Update database button.
  CheckBoxConnect->Checked = true;
  ZodiakDataModule->ADODataSetZodiak->Close();
  ZodiakDataModule->ADODataSetZodiak->CommandType = cmdTable;
  ZodiakDataModule->ADODataSetZodiak->CommandText = "Zodiak";
  ZodiakDataModule->ADODataSetZodiak->Open();
}
//---------------------------------------------------------------------------
void TMainForm::PokazZnakInform(TDataSet* pds,TStrings* pss)
{
  int nn=pds->RecordCount;
  if (nn==0) return;
  //-------------------------------
  TDateTime TheDate(Kalendarz->Date);
  unsigned short year = 0;
  unsigned short month = 0;
  unsigned short day = 0;
  TheDate.DecodeDate(&year, &month, &day);
  //-------------------------------
  pds->First(); /* zapis pierwsza */
  for (int j=0;j<nn;j++)
  {
    short shStartMonth=pds->FieldByName("StartMonth")->AsInteger;
    short shStartDay=pds->FieldByName("StartDay")->AsInteger;
    short shEndMonth=pds->FieldByName("EndMonth")->AsInteger;
    short shEndDay=pds->FieldByName("EndDay")->AsInteger;
    if (month==shStartMonth && day>=shStartDay ||
        month==shEndMonth && day<=shEndDay)
    {/* s sprawdzane dzie i miesic */
      pss->Add(("Informacje o znaku zodiaku:"));
      AnsiString as1=pds->FieldByName("Name")->AsString;
      pss->Add(("  Znak = ") + as1);
      AnsiString as2=pds->FieldByName("Element")->AsString;
      pss->Add(("  ywio = ") + as2);
      AnsiString as3=pds->FieldByName("Planet")->AsString;
      pss->Add(("  Planeta = ") + as3);
      AnsiString as4=pds->FieldByName("Description")->AsString;
      pss->Add(("  Szczegy = ") + as4);
      AnsiString as5=pds->FieldByName("Advice")->AsString;
      pss->Add(("  Rady = ") + as5);
      pss->Add((""));
      pss->Add((""));
      break;
    }
    pds->Next(); /* zapis nastepna */
  }//j
}
//---------------------------------------------------------------------------

