//---plik UnitKlasa.cpp------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "UnitKlasa.h"
//---------------------------------------------------------------------------
dynInt::dynInt()
{ m_pData = NULL;
  m_nSize = m_nMaxSize = m_nGrowBy = 0;
}
dynInt::dynInt(dynInt& ob)
{//konstruktor kopiujcy
  m_nSize=m_nMaxSize=ob.fGetSize();
  m_pData=(int*) new char[m_nSize*sizeof(int)];
  for (int i=0;i<m_nSize;i++)
     m_pData[i]=ob[i];
}
dynInt::dynInt(int size,int growBy)
{ m_nSize = m_nMaxSize = size;
  m_nGrowBy = growBy;
  m_pData=(int*) new char[m_nMaxSize*sizeof(int)];
  memset(m_pData,0,size*sizeof(int)); //zerowanie
}
dynInt::~dynInt()
{ delete [] (char*)m_pData;
}
int dynInt::fGetSize() const
{ return m_nSize;
}
void dynInt::fSetSize(int newsize,int nGrowBy)
{ m_nGrowBy = nGrowBy;
  if (newsize<=0)
  {// zerowa obiekt
    delete [] (char*)m_pData;
    m_pData = NULL;
    m_nSize = m_nMaxSize = 0;
  }
  else
  if (m_pData == NULL)
  {// zaalokowa pierwszy raz
    m_pData = (int*) new char[newsize*sizeof(int)];
    memset(m_pData,0,newsize*sizeof(int)); //zerowanie
    m_nSize = m_nMaxSize = newsize;
  }
  else
  if (newsize <= m_nMaxSize)
  {// alokacja jest niepotrzebna
    if (newsize > m_nSize)
    {//inicjalizacja dodatkowa
      memset(&m_pData[m_nSize],0,(newsize-m_nSize) * sizeof(int));
    }
    m_nSize = newsize;
  }
  else
  {// alokacja jest potrzebna
    int nNewMax;
    if (newsize<m_nMaxSize+m_nGrowBy)
      nNewMax=m_nMaxSize+m_nGrowBy;  // plus krok
    else nNewMax=newsize;
    int *pNew=(int*) new char[nNewMax*sizeof(int)];
    // kopiowanie danych dawnych
    memcpy(pNew,m_pData,m_nSize*sizeof(int));
    // budowanie elementw dodatkowych
    if (newsize > m_nSize)
    { memset(&pNew[m_nSize],0,(newsize-m_nSize) *     sizeof(int));
      // niszczenie alokacji poprzedniej
      delete [] (char*)m_pData;
      m_pData = pNew;
      m_nSize = newsize;
      m_nMaxSize = nNewMax;
    }
  }
}
void dynInt::fSetAtGrow(int nIndex, int newElement)
{/* wpisywanie elementu */
  if (nIndex>=0)
  {
    if (nIndex>=m_nSize)
      fSetSize(nIndex+1,4);
    m_pData[nIndex]=newElement;
  }
}
dynInt& dynInt::operator=(const dynInt& ob)
{/* przeciony operator "=" */
  if (&ob==this) return *this; //przypadek "A=A;"
  if (m_pData) delete [] (char *)m_pData;
  m_nSize=m_nMaxSize=ob.fGetSize();
  m_pData=(int*) new char[m_nSize*sizeof(int)];
  for (int i=0;i<m_nSize;i++) m_pData[i]=ob[i];
  return *this;
};
int& dynInt::operator[](int nIndex)
{/* przeciony operator "[]" */
  static int zero=0;
  if (nIndex >= 0 && nIndex < m_nSize)
    return m_pData[nIndex];
  else return zero;
}
const int& dynInt::operator[](const int nIndex) const
{/* przeciony operator "[]" */
  static int zero=0;
  if (nIndex >= 0 && nIndex < m_nSize)
    return m_pData[nIndex];
  else return zero;
}
int dynInt::operator()(int nBegIndex,int nNumber)
{/* przeciony operator "()" */
  if (nBegIndex<0) nBegIndex=0;
  int nEnd=nBegIndex+nNumber;
  if (nEnd>m_nSize) nEnd=m_nSize;
  int suma=0;
  for (int i=nBegIndex;i<nEnd;i++) suma+=m_pData[i];
  return suma;
}
//=== Przykad. czenie alokacji z inicjalizacj ====
cA::cA()
{ flaga=false;
}
cA::~cA()
{
}
void* cA::operator new(size_t size)
{/* przeciony operator new */
  cA *ptr=(cA *)::new char[size];//operator globalny
  ptr->buffer=::new char[10];//operator globalny
  for (int i=0;i<10;i++) ptr->buffer[i]='.';
  return ptr;
}
void cA::operator delete(void* ptr)
{/* przeciony operator delete */
  if (((cA *)ptr)->flaga)
  {
    ::delete [] ((cA *)ptr)->buffer;//operator globalny
    ((cA *)ptr)->buffer=NULL;
    ::delete ptr;//operator globalny
  }
}
//=== Przykad. Przekazywanie argumentw operatowi new ===
cB::~cB()
{ delete [] buffer; // operator globalny
  buffer=NULL;
}
void* cB::operator new(size_t size,int volumn,int symbol)
{/* przeciony operator new z argumentami */
  cB *ptr=(cB *)new char[size]; // operator globalny
  ptr->buffer=new char[volumn]; // operator globalny
  for (int i=0;i<volumn;i++) ptr->buffer[i]=(char)symbol;
  return ptr;
}

#pragma package(smart_init)
