//---plik UnitKlasa.h---------------------------
#include <vcl.h>
#ifndef UnitKlasaH
#define UnitKlasaH
//----------------------------------------------
//=== Przykad. Deklaracja w jzyku C++ wzorca klas Kwadraty
template <typename Typ> class Kwadraty
{// deklaracja wzorca
  Typ bok;
public:
  Kwadraty(Typ arg){ bok=arg; };
  void Rysuj(TPaintBox* pb,int x0,int y0);
  void RysujInt(int d,TPaintBox* pb,int x0,int y0);
};
void Kwadraty<int>::Rysuj(TPaintBox* pb,int x0,int y0)
{// metoda dla typu danych "int"
  RysujInt(bok,pb,x0,y0);
}
void Kwadraty<double>::Rysuj(TPaintBox* pb,int x0,int y0)
{// metoda dla typu danych "double"
  int d=(int)bok;
  RysujInt(d,pb,x0,y0);
}
void Kwadraty<AnsiString>::Rysuj(TPaintBox* pb,int x0,int y0)
{// metoda dla typu danych "AnsiString"
  int d=bok.ToInt();
  RysujInt(d,pb,x0,y0);
}
template <typename Typ> void Kwadraty<Typ>::RysujInt(int d,TPaintBox* pb,int x0,int y0)
{//metoda "wzorcowa"
  pb->Canvas->Pen->Color=clRed;
  pb->Canvas->Brush->Color=clRed;
  pb->Canvas->Rectangle(x0,y0,x0+d,y0+d);
}

//=== Przykad. Definicja wzorca funkcji
template <typename typ> int Porown(typ a1,typ a2)
{/* wzorzec funkcji porwnania*/
  return (a1==a2)? 0: ((a1>a2)? +1: -1);
}
class Prostokat
{
protected: int dlug,szerok;
public:
  Prostokat(int d,int s); //konstruktor obiektw
  const bool operator==(const Prostokat& ob2) const;
  const bool operator>(const Prostokat& ob2) const;
  int Pole() const;
};
Prostokat::Prostokat(int d,int s)
{//konstruktor obiektw
 dlug=d; szerok=s;
}
const bool Prostokat::operator==(const Prostokat& ob2) const
{ int p1=Pole(); int p2=ob2.Pole();
  return p1==p2;
}
const bool Prostokat::operator>(const Prostokat& ob2) const
{ int p1=Pole(); int p2=ob2.Pole();
  return p1>p2;
}
int Prostokat::Pole() const
{//metoda "Pole"
 return szerok*dlug;
}

#endif
